## commander-genius 3.6.1+dfsg

=== CMakeLists.txt ===
# CMake file for development of Commander Genius
cmake_minimum_required(VERSION 3.12)

Project(CommanderGenius)

IF(WIN32)
SET(DATADIR CGenius)
SET(APPDIR CGenius)
SET(GAMES_SHAREDIR "${APPDIR}" CACHE PATH "Game data root dir")
SET(DOCDIR ${DATADIR} CACHE PATH "Docs destination")
ELSE(WIN32)
SET(SHAREDIR "/usr/share" CACHE PATH "System share dir location")
SET(GAMES_SHAREDIR "${SHAREDIR}/games/" CACHE PATH "Game data root dir")
SET(DATADIR "${GAMES_SHAREDIR}/commandergenius")
SET(APPDIR games CACHE PATH "Binary destination")
SET(DOCDIR ${DATADIR} CACHE PATH "Docs destination")
SET(ICONDIR "${SHAREDIR}/icons/hicolor" CACHE PATH "Standard icon installation dir")
SET(DESKTOPFILESDIR "${SHAREDIR}/applications" CACHE PATH "Application installation dir")
ENDIF(WIN32)

if (OSXCROSS)
message(STATUS "OSXCross is enabled")
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
include(${CMAKE_TOOLCHAIN_FILE})
endif()


option(USE_VIRTUALPAD "Enable Onscreen Virtual Gamepad support " ON)

option(EMBEDDED "Set this to yes, if you want a build for embedded systems" OFF)

if(ALTERNATE_HOME)
    ADD_DEFINITIONS(-DALTERNATE_HOME="${ALTERNATE_HOME}")
    MESSAGE(STATUS "ALTERNATE_HOME=${ALTERNATE_HOME}")
endif(ALTERNATE_HOME)

if(EMBEDDED)
    ADD_DEFINITIONS(-DEMBEDDED)
endif(EMBEDDED)

if(USE_VIRTUALPAD)
    ADD_DEFINITIONS(-DUSE_VIRTUALPAD)
endif(USE_VIRTUALPAD)

# In case you want a switch build
OPTION(NINTENDO_SWITCH "Build for Nintendo Switch" No)

if(NINTENDO_SWITCH)
    ADD_DEFINITIONS(-D__SWITCH__)
endif(NINTENDO_SWITCH)


# GP2X builds
OPTION(GP2X "Build for GP2X" No)

if(GP2X)
    ADD_DEFINITIONS(-D__GP2X__)
endif()


OPTION(DUMP_MTCS "Show Mouse Touch Cursor Position" No)

IF (DUMP_MTCS)
    ADD_DEFINITIONS(-DDUMP_MTCS)
endif(DUMP_MTCS)

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache) # Less useful to do it for linking, see edit2
    message(STATUS "Using ccache for faster builds")
endif(CCACHE_FOUND)

# Will pass the SHA and branch strings to the executable
find_program(GIT_FOUND git)
if(GIT_FOUND)
    message(STATUS "Found Git (${GIT_FOUND}), executable will get SHA and branch used")
    execute_process(COMMAND ${GIT_FOUND} -C ${CMAKE_SOURCE_DIR} rev-parse --short HEAD
                    OUTPUT_VARIABLE GIT_SHA
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${GIT_FOUND} -C ${CMAKE_SOURCE_DIR} rev-parse --abbrev-ref HEAD
                    OUTPUT_VARIABLE GIT_BRANCH
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    ADD_DEFINITIONS(-DGIT_SHA=${GIT_SHA})
    ADD_DEFINITIONS(-DGIT_BRANCH=${GIT_BRANCH})
    message(STATUS "GIT_SHA = ${GIT_SHA}")
    message(STATUS "GIT_BRANCH = ${GIT_BRANCH}")
else(GIT_FOUND)
    ADD_DEFINITIONS(-DGIT_SHA=none)
    ADD_DEFINITIONS(-DGIT_BRANCH=none)
endif(GIT_FOUND)

# Pass correct definition for SYSTEM_DATA_DIR so packager or distributors can decide where the app should land in
if(UNIX)
        if(NOT IS_ABSOLUTE ${GAMES_SHAREDIR})
                set(FULL_GAMES_SHAREDIR "${CMAKE_INSTALL_PREFIX}/${GAMES_SHAREDIR}" CACHE PATH "Full where the games will be stored")
        else()
                set(FULL_GAMES_SHAREDIR ${GAMES_SHAREDIR} CACHE PATH "Full where the games will be stored")
        endif()
endif(UNIX)

set(SYSTEM_DATA_DIR "${FULL_GAMES_SHAREDIR}" CACHE PATH "System data where CG will access to" )
MESSAGE(STATUS "Setting SYSTEM_DATA_DIR to ${SYSTEM_DATA_DIR}" )
add_definitions(-DSYSTEM_DATA_DIR="${SYSTEM_DATA_DIR}")


# Add GsKit
add_subdirectory("GsKit")

option(DISABLE_HOVER "Disables the hover over effect in the menus, useful for touch based devices" OFF)

if(DISABLE_HOVER)
    ADD_DEFINITIONS(-DDISABLE_HOVER)
endif()

# Modules path located at GsKit/CMake
#set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/GsKit/CMake")

if(${CMAKE_VERSION} VERSION_GREATER "3.8.0")
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
else()
    if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
      set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++17")
      set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++17")
    elseif (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.1)
      set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++1z")
      set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++1z")
    endif()
endif()

#------------------------------------------------------------------------------
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
else()
  message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
endif()

# Since shell script get_version is not processed properly on windows, we have to define manually here.
# TODO: Better system for defining the version
set(CG_VERSION "3.6.1")

MESSAGE(STATUS "Preparing the Build-System for Commander Genius" )
execute_process(COMMAND bash ${CMAKE_CURRENT_SOURCE_DIR}/get_version.sh OUTPUT_VARIABLE CG_VERSION)
string(REGEX REPLACE "[\r\n]" "" CG_VERSION "${CG_VERSION}")

# Generate the README file with the correct version string
configure_file(README.md ${CMAKE_BINARY_DIR}/README.md COPYONLY)
configure_file(README.md ${CMAKE_CURRENT_SOURCE_DIR}/README.md COPYONLY)
configure_file(README.md ${CMAKE_CURRENT_SOURCE_DIR}/debian/README.md COPYONLY)
configure_file(GsKit/LICENSE ${CMAKE_BINARY_DIR}/LICENSE COPYONLY)

if(APPLE)
    file(COPY cglogo.icns DESTINATION ${CMAKE_BINARY_DIR}/src)
    file(COPY Info.plist DESTINATION ${CMAKE_BINARY_DIR}/src)
    file(COPY launchCGonMacOs.sh DESTINATION ${CMAKE_BINARY_DIR})
    file(COPY buildMacOsBundle.sh DESTINATION ${CMAKE_BINARY_DIR})
    file(COPY makebundleable.sh DESTINATION ${CMAKE_BINARY_DIR})
    file(COPY get_version.sh DESTINATION ${CMAKE_BINARY_DIR})
    file(COPY version.h DESTINATION ${CMAKE_BINARY_DIR})
    SET(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -headerpad_max_install_names")
endif(APPLE)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")


# Check that GsKit also has been loaded
if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/GsKit/CMakeLists.txt")
    MESSAGE(FATAL_ERROR "You need to have the sources of GsKit in order to build Commander Genius. ")
endif()

# And build Commander Genius on top of that!
add_subdirectory("src")

add_custom_target(${PROJECT_NAME} SOURCES changelog.txt README.md)

MESSAGE(STATUS "CG_VERSION = ${CG_VERSION}" )

INCLUDE(package.cmake)

MESSAGE( STATUS "Build system is prepared. To Build the project just type \"make\"" )
MESSAGE( STATUS "If you want to create the installation package just type \"make package\" after you build the project" )

=== GsKit/CMakeLists.txt ===
# CMake file for development of Commander Genius

cmake_minimum_required(VERSION 3.12)

Project(GsKit)

OPTION(USE_BOOST "Use Boost for XML" No)

option(DISABLE_HOVER "Disables the hover over effect in the menus, useful for touch based devices" OFF)

if(DISABLE_HOVER)
    ADD_DEFINITIONS(-DDISABLE_HOVER)
endif()

option(USE_CRASHHANDLER "Enables the Crash Handler" ON)
if(USE_CRASHHANDLER)
    ADD_DEFINITIONS(-DUSE_CRASHHANDLER)
endif()

OPTION(USE_OPENGL "OpenGL support" No)


if(USE_BOOST)
    set(Boost_USE_STATIC_LIBS OFF)
    set(Boost_USE_MULTITHREAD ON)
    set(Boost_USE_STATIC OFF)

    FIND_PACKAGE(Boost)
    IF (Boost_FOUND)
            INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
            ADD_DEFINITIONS( "-DBOOST_ENABLED" )
    ELSE(Boost_FOUND)
            MESSAGE(FATAL_ERROR "Could not find the Boost libraries")
    ENDIF(Boost_FOUND)
endif(USE_BOOST)


INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})


if(CMAKE_SYSTEM_NAME MATCHES "Emscripten")

  set(CMAKE_CXX_FLAGS_INIT "-s WASM=1 -s USE_SDL=2 -s USE_SDL_IMAGE=2 -s SDL2_IMAGE_FORMATS='[\"png\"]'")
  set(CMAKE_EXE_LINKER_FLAGS_INIT "-s WASM=1 -s USE_SDL=2 -s USE_SDL_IMAGE=2 -s SDL2_IMAGE_FORMATS='[\"png\"]'")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_INIT}")
  set(CMAKE_EXE_LINKER "${CMAKE_EXE_LINKER_FLAGS_INIT} -s EXTRA_EXPORTED_RUNTIME_METHODS='[\"ccall\", \"cwrap\"]'")

  # TODO: Needs rework
  add_library(GsKit STATIC ${ALL_SRCS_GSKIT_BASE})

else()

    # Hack which on some systems helps linking this lib correctly
    # (required for mac builds)
    file(WRITE null.cpp "")
    add_library(${PROJECT_NAME} LICENSE null.cpp LICENSE)


    if(SDL2)
        OPTION(USE_OPENGL "OpenGL support" No)
    else()
        OPTION(USE_OPENGL "OpenGL support" Yes)
    endif()

    option(USE_VIRTUALPAD "Enable Onscreen Virtual Gamepad support " ON)

    if(USE_VIRTUALPAD)
        ADD_DEFINITIONS(-DVIRTUALPAD)
    endif(USE_VIRTUALPAD)

    set (CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/CMake")

    if(${CMAKE_VERSION} VERSION_GREATER "3.8.0")
        set(CMAKE_CXX_STANDARD 17)
        set(CMAKE_CXX_STANDARD_REQUIRED ON)
    else()
        if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
          set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++17")
          set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++17")
        elseif (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.1)
          set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++1z")
          set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++1z")
        endif()
    endif()

    IF(WIN32)
        ADD_DEFINITIONS(-DWIN32)
    ENDIF(WIN32)

    IF (USE_OPENGL)
            ADD_DEFINITIONS(-DGL)
            ADD_DEFINITIONS(-DUSE_OPENGL)
    ENDIF (USE_OPENGL)


    # If we want to debug set the proper flags or have release etc.
    IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
            ADD_DEFINITIONS(-DDEBUG)
            ADD_DEFINITIONS(-g)
            ADD_DEFINITIONS(-O0)
            ADD_DEFINITIONS(-Wall)
    ELSEIF(CMAKE_BUILD_TYPE STREQUAL "Release")
            ADD_DEFINITIONS(-DRELEASE)
            ADD_DEFINITIONS(-O2)
    ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")

    IF(USE_OPENGL)
        # OpenGL Parsing
        set(OpenGL_GL_PREFERENCE GLVND)
        find_package(OpenGL REQUIRED)

        ADD_DEFINITIONS(-DGL)
        ADD_DEFINITIONS(-DUSE_OPENGL)
    ENDIF (USE_OPENGL)

    add_subdirectory(fileio)
    add_subdirectory(graphics)
    add_subdirectory(widgets)

    add_subdirectory(base)

    Target_link_libraries(${PROJECT_NAME} GsKit_base)
    Target_link_libraries(${PROJECT_NAME} GsKit_fileio)
    Target_link_libraries(${PROJECT_NAME} GsKit_widgets)
    Target_link_libraries(${PROJECT_NAME} GsKit_graphics)

IF(USE_OPENGL)
    # OpenGL stuff to link
    target_link_libraries(${PROJECT_NAME} ${OPENGL_LIBRARIES})
ENDIF(USE_OPENGL)


endif()

=== src/CMakeLists.txt ===
# Platform specific things can be put here
# Compilers and other specific variables can be found here:
# http://www.cmake.org/Wiki/CMake_Useful_Variables

OPTION(DOWNLOADER "Internal Downloader" Yes)


IF(WIN32)
        SET(BUILD_TARGET WIN32)
        ADD_DEFINITIONS(-DWIN32)
        ADD_DEFINITIONS(-DTARGET_WIN32)
ELSEIF(UNIX)
        SET(BUILD_TARGET LINUX)
ENDIF()

IF(APPLE)
    SET(BUILD_TARGET APPLE)
endif()

IF(NOT DEFINED BUILD_TARGET)
    MESSAGE( STATUS "WARNING: You did not specify the build type with the -DBUILD_TARGET= Parameter. ${BUILD_TARGET} has been choosen" )
    MESSAGE( STATUS "Available builds are: WIN32, LINUX GP2X. WIZ, CAANOO, DINGOO, NANONOTE" )
ENDIF(NOT DEFINED BUILD_TARGET)


SET(USRDIR /usr)

include(oldArch.cmake)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#Alignment error report is important for android builds
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=cast-align")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=cast-align")

# Main includes
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/GsKit)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMake)

# If we want to debug set the proper flags or have release etc.
IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
        ADD_DEFINITIONS(-DDEBUG)
        ADD_DEFINITIONS(-g)
        ADD_DEFINITIONS(-O0)
        ADD_DEFINITIONS(-Wall)
ELSEIF(CMAKE_BUILD_TYPE STREQUAL "Release")
        ADD_DEFINITIONS(-DRELEASE)
        ADD_DEFINITIONS(-O2)
ENDIF()


# Make sure the linker can find the GsKit library once it is built.
link_directories (${CMAKE_BINARY_DIR}/GsKit)

MESSAGE( STATUS "Internal Downloader: ${DOWNLOADER}" )

add_subdirectory(engine)

if(GP2X)
    add_subdirectory(sys)
endif(GP2X)

add_subdirectory(fileio)
add_subdirectory(dialog)

# Get all the o-files from the different targets and link'em
get_property(cg_obj_libs GLOBAL PROPERTY CG_OBJ_LIBS)

if(OPT_PATH)
    MESSAGE(STATUS "OPT_PATH = ${OPT_PATH}")
    link_directories(${OPT_PATH}/local/lib)
endif(OPT_PATH)


set(CGENIUS_SRC CGenius.cpp
    misc.cpp
    ${cg_obj_libs})

if(NINTENDO_SWITCH)
    set(CGENIUS_SRC ${CGENIUS_SRC} switch.c)
endif(NINTENDO_SWITCH)

if(${CMAKE_VERSION} VERSION_LESS "3.11.0")
    if(ANDROID)
        message(STATUS "Android build enabled. Building CG as Shared Lib")
        add_library(CGeniusExe SHARED ${CGENIUS_SRC})
    else(ANDROID)
        # Add executable Commander Genius
        add_executable (CGeniusExe ${CGENIUS_SRC})
    endif(ANDROID)
else()
    if(ANDROID)
        message(STATUS "Android build enabled. Building CG as Shared Lib")
        add_library(CGeniusExe SHARED)
    else(ANDROID)
        # Add executable Commander Genius
        add_executable (CGeniusExe)
    endif(ANDROID)

    target_sources(CGeniusExe PRIVATE ${CGENIUS_SRC})
endif()

# Since some RefKeen is used, we also need C99 Standard
set_property(TARGET CGeniusExe PROPERTY C_STANDARD 99)

# Link CG Engines
target_link_libraries (CGeniusExe engine)

# Link GsKit
target_link_libraries (CGeniusExe GsKit)


# The Windows Version has an icon in the executable
IF(WIN32)
        SET_TARGET_PROPERTIES(CGeniusExe PROPERTIES OUTPUT_NAME "CGenius")
        find_program(WINDRES_FOUND ${CMAKE_RC_COMPILER})
        if(WINDRES_FOUND)
            ADD_CUSTOM_COMMAND(TARGET CGeniusExe PRE_LINK COMMAND ${WINDRES_FOUND} ${CMAKE_CURRENT_SOURCE_DIR}/CGLogo.rc ${CMAKE_CURRENT_SOURCE_DIR}/CGLogo.o)
            SET_TARGET_PROPERTIES(CGeniusExe PROPERTIES LINK_FLAGS "-mwindows ${CMAKE_CURRENT_SOURCE_DIR}/CGLogo.o")
            MESSAGE(STATUS "Will build with the CG icon for Windows." )
        else()
            SET_TARGET_PROPERTIES(CGeniusExe PROPERTIES LINK_FLAGS "-mwindows")
        endif(WINDRES_FOUND)
ENDIF(WIN32)



# Only for SDL2 and Win32 since it is updated for that platform.
if(WIN32)
        target_link_libraries(CGeniusExe mingw32)
        target_link_libraries(CGeniusExe user32)
        target_link_libraries(CGeniusExe gdi32)
        target_link_libraries(CGeniusExe winmm)
        target_link_libraries(CGeniusExe imm32)
        target_link_libraries(CGeniusExe version)
endif(WIN32)

# Stuff definitions in case we want to install it
INCLUDE(install.cmake)

=== GsKit/base/CMakeLists.txt ===
Project(GsKit_base)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

add_subdirectory(interface)
add_subdirectory(lua)
add_subdirectory(video)
add_subdirectory(audio)

include_directories(lua)

set(HEADERS CInput.h        GsEventContainer.h       PointDevice.h
Configurator.h  GsEvent.h           GsTimer.h         Singleton.h
GsApp.h         GsGear.h            GsTTFSystem.h     TypeDefinitions.h
GsArguments.h   GsLogging.h         GsVirtualinput.h  Vector2D.h
GsEngine.h      GsLua.h             InputEvents.h     CRingBuffer.h
direction.h )

set(SRCS CInput.cpp       GsEngine.cpp          GsLogging.cpp  GsTimer.cpp
GsApp.cpp        GsEventContainer.cpp  GsLua.cpp      GsTTFSystem.cpp
GsArguments.cpp  GsEvent.cpp           TypeDefinitions.cpp
)

add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

target_link_libraries(${PROJECT_NAME} GsKit_base_interface)
target_link_libraries(${PROJECT_NAME} GsKit_base_lua)
target_link_libraries(${PROJECT_NAME} GsKit_base_video)
target_link_libraries(${PROJECT_NAME} GsKit_base_audio)

target_link_libraries(${PROJECT_NAME} GsKit_widgets)

=== GsKit/fileio/CMakeLists.txt ===


Project(GsKit_fileio)

set(HEADERS CConfiguration.h  IniReader.h  ResourceMgmt.h fileio.h)

set(SRCS CConfiguration.cpp  IniReader.cpp  ResourceMgmt.cpp fileio.cpp)

add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

target_link_libraries(${PROJECT_NAME} GsKit_base_interface)

=== GsKit/graphics/CMakeLists.txt ===


Project(GsKit_graphics)

set(HEADERS cgttf.h   GsFont.h     GsGraphics.h    GsSurface.h
    GsTrueTypeFont.h  GsBitmap.h   GsFontLegacy.h  GsPalette.h
    GsTexture.h       GsCursor.h   GsGametext.h    GsSprite.h
    GsTilemap.h       GsDynColor.h CColorMerge.h   CDimDark.h
    GsScrollsurface.h
    GsTextureElem.cpp
    CFlash.h          CPixelate.h    CScrollEffect.h    CVibrate.h)

set(SRCS cgttf.cpp     GsFontLegacy.cpp  GsSprite.cpp   GsTrueTypeFont.cpp
    GsBitmap.cpp       GsGametext.cpp    GsSurface.cpp
    GsCursor.cpp       GsGraphics.cpp    GsTexture.cpp
    GsScrollsurface.cpp
    GsFont.cpp         GsPalette.cpp     GsTilemap.cpp GsDynColor.cpp
    CColorMerge.cpp    CDimDark.cpp      CPixelate.cpp CFlash.cpp
    GsTextureElem.cpp
    CScrollEffect.cpp  CVibrate.cpp  )


#include_directories(${SDL_INCLUDE_DIR})


add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

target_link_libraries(${PROJECT_NAME} GsKit_base_interface)
target_link_libraries(${PROJECT_NAME} GsKit_base)
target_link_libraries(${PROJECT_NAME} GsKit_fileio)

=== GsKit/widgets/CMakeLists.txt ===


Project(GsKit_widgets)

set(HEADERS down.h            GsComboSelection.h  GsMiniTextViewer.h  GsSelectableText.h
    GsBanner.h        GsControl.h         GsNumberControl.h   GsText.h
    GsBaseMenu.h      GsDialog.h          GsProgressbar.h     GsTextSelectionList.h
    GsSelectionList.h
    GsBitmapBox.h     GsFrame.h           GsRegister.h        GsWidget.h
    GsBitmapButton.h  GsInputText.h       GsScrollbar.h       GsWidgetsManager.h
    GsButton.h        GsMenuController.h  GsScrollingFrame.h  up.h
    GsSelectableChkboxItem.h GsCheckbox.h)

set(SRCS GsBanner.cpp          GsFrame.cpp           GsScrollingFrame.cpp
    GsBaseMenu.cpp        GsInputText.cpp       GsSelectableText.cpp
    GsBitmapBox.cpp       GsMenuController.cpp  GsText.cpp
    GsBitmapButton.cpp    GsMiniTextViewer.cpp  GsTextSelectionList.cpp
    GsSelectionList.cpp
    GsButton.cpp          GsNumberControl.cpp   GsWidget.cpp
    GsComboSelection.cpp  GsProgressbar.cpp     GsWidgetsManager.cpp
    GsControl.cpp         GsRegister.cpp
    GsDialog.cpp          GsScrollbar.cpp
    GsSelectableChkboxItem.cpp GsCheckbox.cpp)

add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

target_link_libraries(${PROJECT_NAME} GsKit_graphics)

=== src/dialog/CMakeLists.txt ===

include_directories(${SDL_INCLUDE_DIR})

set(CXXSRC
    CDlgFrame.cpp
    CDlgOptionText.cpp
    CMessageBox.cpp
    CTextViewer.cpp)

set(HSRC
    CDlgFrame.h
    CDlgOptionText.h
    CMessageBox.h
    CTextViewer.h)

add_library(cg_dialog STATIC ${CXXSRC} ${HSRC})

target_link_libraries(cg_dialog GsKit_base_interface)

=== src/engine/CMakeLists.txt ===
include_directories(${SDL_INCLUDE_DIR})

option(BUILD_COSMOS  "Build Cosmos engine" no)
option(BUILD_KEEN    "Build Keen engine" yes)
option(BUILD_REFKEEN "Build RefKeen engine" yes)

add_subdirectory(core)

if(BUILD_KEEN)
    add_subdirectory(keen)
    MESSAGE(STATUS "Keen engine build enabled")
endif(BUILD_KEEN)

if(BUILD_REFKEEN)
    add_subdirectory(refkeen)
    MESSAGE(STATUS "Refkeen engine build enabled")
endif(BUILD_REFKEEN)

if(BUILD_COSMOS)
        add_definitions(-DBUILD_COSMOS)
        add_subdirectory(cosmos)
        MESSAGE(STATUS "Cosmos build enabled")
endif(BUILD_COSMOS)


# Move this to somewhere else
add_subdirectory(unzip)
add_subdirectory(depklite)

set(CXXSRC CGameLauncher.cpp
           downloadgui.cpp
           gamedownloader.cpp
           gameselector.cpp)


set(HSRC CGameLauncher.h
         downloadgui.h
         gamedownloader.h
         gameselector.h)

add_library(engine STATIC ${CXXSRC}
                          ${HSRC}
                          gamelauncher.menu)

if(DOWNLOADER)
    target_compile_definitions(engine PRIVATE -DDOWNLOADER)

    FIND_PACKAGE(CURL REQUIRED)

    if(CURL_FOUND)
      message(STATUS "Found curl version ${CURL_VERSION_STRING}")
      if(${CURL_VERSION_STRING} VERSION_LESS "7.32")
        message(FATAL_ERROR "curl version must be at least 7.32")
      endif()
      if(WIN32)
        message(STATUS "Enforcing the use of curl as static library")
        target_compile_definitions(engine PRIVATE -DCURL_STATICLIB)
      endif()
        target_include_directories(engine PRIVATE ${CURL_INCLUDE_DIR})
    else()
      message(FATAL_ERROR "curl library not found")
    endif()

endif()


if (NOT OSXCROSS)
    add_executable(xxd xxd.c)
endif()

add_custom_target(
  createGameLauncherMenu
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND xxd -i gamelauncher.menu ${CMAKE_CURRENT_BINARY_DIR}/gamelauncher.menu.h
)

set_property(TARGET createGameLauncherMenu APPEND PROPERTY SOURCES gameselector.h gameselector.cpp)

add_dependencies(engine createGameLauncherMenu)

target_include_directories(engine PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

if(BUILD_KEEN)
  target_link_libraries(engine engine_keen_galaxy engine_keen_vorticon)
endif(BUILD_KEEN)

if(BUILD_REFKEEN)
  target_link_libraries(engine refkeen engine_keen_dreams)
endif(BUILD_REFKEEN)

if(BUILD_COSMOS)
  target_link_libraries(engine cosmos_engine)
endif(BUILD_COSMOS)


target_link_libraries(engine
                      cg_dialog
                      unzip
                      depklite)

TARGET_LINK_LIBRARIES(engine ${CURL_LIBRARIES})

=== src/fileio/CMakeLists.txt ===

add_subdirectory(compression)

include_directories(${SDL_INCLUDE_DIR})

add_library(fileio STATIC CExeFile.cpp
    CPatcher.cpp
    CPatcherUtils.cpp
    crc.cpp
    CSaveGameController.cpp
    CTileLoader.cpp
    KeenFiles.cpp
    lz.cpp
    CExeFile.h
    CPatcher.h
    crc.h
    CSaveGameController.h
    CTileLoader.h
    CTileProperties.h
    KeenFiles.h
    lz.h
    Oldsavegamestructs.h)

target_link_libraries(fileio GsKit)

target_link_libraries(fileio fileio_compression)

=== src/sys/CMakeLists.txt ===
include_directories(${SDL_INCLUDE_DIR})
add_library(sdl_extensions_sys STATIC wizgp2x.cpp wizgp2x.h)

=== tools/IMFPlayer/CMakeLists.txt ===
# CMake file for development of IMF Player
# This CMake file is used under Linux normally. 

cmake_minimum_required(VERSION 2.4)
IF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} GREATER 2.4)
	cmake_policy(SET CMP0005 OLD)
	cmake_policy(SET CMP0003 OLD)
	#include(PCHSupport_26.cmake)
ENDIF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} GREATER 2.4)

	MESSAGE( "Preparing the Build-System for IMF Player" )

# This parts detects, if we are working on a 64-bit System
#IF( NOT APPLE )
#	IF( CMAKE_SIZEOF_VOID_P MATCHES 4 )
#	  set( HAVE_64_BIT 0 )
#	ELSEIF( CMAKE_SIZEOF_VOID_P MATCHES 8 )
#	  set( HAVE_64_BIT 1 )
#	ELSE( CMAKE_SIZEOF_VOID_P MATCHES 4 )
#	  set( HAVE_64_BIT 0 )
#	ENDIF( CMAKE_SIZEOF_VOID_P MATCHES 4 )
#ENDIF( NOT APPLE )
#set( HAVE_64_BIT 0 )

OPTION(DEBUG "enable debug build" Yes)
OPTION(SDL "SDL support (will not work without)" Yes)

IF (DEBUG)
	SET(CMAKE_BUILD_TYPE Debug)
ELSE (DEBUG)
	SET(CMAKE_BUILD_TYPE Release)
ENDIF (DEBUG)

# Platform specific things can be put here
# Compilers and other specific variables can be found here:
# http://www.cmake.org/Wiki/CMake_Useful_Variables


# Check wether in what system it is configured
IF(NOT HAVE_64_BIT AND BUILD_TYPE STREQUAL LINUX64)
	MESSAGE( "Warning: Building 64-bit Version on 32-bit machine is not supported!" )
ENDIF(NOT HAVE_64_BIT AND BUILD_TYPE STREQUAL LINUX64)


# Directory creation of all the builds
EXEC_PROGRAM(mkdir ARGS -p ${CMAKE_CURRENT_SOURCE_DIR}/build OUTPUT_VARIABLE NULL)
EXEC_PROGRAM(mkdir ARGS -p ${CMAKE_CURRENT_SOURCE_DIR}/build/Linux32 OUTPUT_VARIABLE NULL)
EXEC_PROGRAM(mkdir ARGS -p ${CMAKE_CURRENT_SOURCE_DIR}/build/Linux64 OUTPUT_VARIABLE NULL)
EXEC_PROGRAM(mkdir ARGS -p ${CMAKE_CURRENT_SOURCE_DIR}/build/Win32 OUTPUT_VARIABLE NULL)
EXEC_PROGRAM(mkdir ARGS -p ${CMAKE_CURRENT_SOURCE_DIR}/build/Xcode OUTPUT_VARIABLE NULL)

PROJECT(imfplayer)

# main includes
INCLUDE_DIRECTORIES(optional-includes/generated)
INCLUDE_DIRECTORIES(src)
#INCLUDE_DIRECTORIES(src/fileio)
#INCLUDE_DIRECTORIES(src/hardware)
#INCLUDE_DIRECTORIES(src/sdl/music)

AUX_SOURCE_DIRECTORY(src ROOT_S)
AUX_SOURCE_DIRECTORY(src/hardware HARDWARE_S)
AUX_SOURCE_DIRECTORY(src/sdl/music SDLMUSIC_S)

SET(ALL_SRCS ${ROOT_S} ${HARDWARE_S} ${SDLMUSIC_S})

IF(UNIX)
# Compilation under Linux
	ADD_DEFINITIONS("-c -fmessage-length=0")

	IF(BUILD_TYPE STREQUAL WIN32)
		set(PREFIX /usr/i586-mingw32msvc/include)
		set(CMAKE_INCLUDE_PATH ${PREFIX})
		set(CMAKE_C_COMPILER i586-mingw32msvc-gcc)
		set(CMAKE_CXX_COMPILER i586-mingw32msvc-g++)
		set(CMAKE_FIND_ROOT_PATH ${PREFIX})
		set(CMAKE_INSTALL_PREFIX ${PREFIX})
		SET(BUILD_DIR Win32)
		ADD_DEFINITIONS(-DWIN32)
		ADD_DEFINITIONS(-DTARGET_WIN32)
		
	ELSEIF(BUILD_TYPE STREQUAL LINUX32)
		ADD_DEFINITIONS("-DTARGET_LNX")

		IF(HAVE_64_BIT)
			ADD_DEFINITIONS(-D__i386__)
			ADD_DEFINITIONS(-m32)
		ELSE(HAVE_64_BIT)
		ENDIF(HAVE_64_BIT)
		SET(BUILD_DIR Linux32)

	ELSEIF(BUILD_TYPE STREQUAL LINUX64)
		ADD_DEFINITIONS("-DTARGET_LNX")
		SET(BUILD_DIR Linux64)
	ELSE(BUILD_TYPE STREQUAL WIN32)
	ENDIF(BUILD_TYPE STREQUAL WIN32)

	SET(OPTIMIZE_COMPILER_FLAG -O3)
ENDIF(UNIX)


IF (SDL)
	ADD_DEFINITIONS(-DSDL)

	IF(BUILD_TYPE STREQUAL WIN32)
		INCLUDE_DIRECTORIES(/usr/i586-mingw32msvc/include/SDL)
	ELSE(BUILD_TYPE STREQUAL WIN32)
		INCLUDE_DIRECTORIES(/usr/include/SDL)
	ENDIF(BUILD_TYPE STREQUAL WIN32)
ENDIF (SDL)

IF(DEBUG)
	ADD_DEFINITIONS(-DDEBUG)
ENDIF(DEBUG)

# Executable definition
ADD_EXECUTABLE(imfplayer ${ALL_SRCS})

# Linking part under Linux
IF(SDL)	
	IF(BUILD_TYPE STREQUAL WIN32)
		TARGET_LINK_LIBRARIES(imfplayer mingw32)
		TARGET_LINK_LIBRARIES(imfplayer SDLmain)
		TARGET_LINK_LIBRARIES(imfplayer SDL)
	ELSEIF(BUILD_TYPE STREQUAL LINUX32)
		IF(HAVE_64_BIT)
			TARGET_LINK_LIBRARIES(imfplayer SDL-1.2)
		ELSE(HAVE_64_BIT)
			TARGET_LINK_LIBRARIES(imfplayer SDL)
		ENDIF(HAVE_64_BIT)
	ELSE(BUILD_TYPE STREQUAL LINUX32)
		TARGET_LINK_LIBRARIES(imfplayer SDL)
	ENDIF(BUILD_TYPE STREQUAL WIN32)
ENDIF(SDL)

IF(BUILD_TYPE STREQUAL LINUX32)
	IF(HAVE_64_BIT)
		SET_TARGET_PROPERTIES(imfplayer PROPERTIES LINK_FLAGS -L/usr/lib32)
		SET_TARGET_PROPERTIES(imfplayer PROPERTIES LINK_FLAGS -m32)
	ENDIF(HAVE_64_BIT)
ENDIF(BUILD_TYPE STREQUAL LINUX32)

IF(BUILD_TYPE STREQUAL WIN32)
	SET_TARGET_PROPERTIES(imfplayer PROPERTIES LINK_FLAGS -L/usr/i586-mingw32msvc/lib)
	SET_TARGET_PROPERTIES(imfplayer PROPERTIES LINK_FLAGS -mwindows)
ENDIF(BUILD_TYPE STREQUAL WIN32)

# Set binary(executable) file name. In Windows this filename needs the exe extension
# The Windows Version has an icon in the executable
IF(BUILD_TYPE STREQUAL WIN32)
	SET_TARGET_PROPERTIES(imfplayer PROPERTIES OUTPUT_NAME "build/${BUILD_DIR}/IMFPlayer.exe")
ELSE(BUILD_TYPE STREQUAL WIN32)
	SET_TARGET_PROPERTIES(imfplayer PROPERTIES OUTPUT_NAME "build/${BUILD_DIR}/IMFPlayer")
ENDIF(BUILD_TYPE STREQUAL WIN32)

IF(NOT DEFINED BUILD_TYPE)
	SET(BUILD_TYPE LINUX32)
	MESSAGE( "WARNING: You did not specify the build type with the -DBUILD_TYPE= Parameter. LINUX32 has been choosen" )
	MESSAGE( "Available Builds are: WIN32, LINUX32, LINUX64, For 64-bit Linux use 'cmake . -DBUILD_TYPE=LINUX64'" )
ENDIF(NOT DEFINED BUILD_TYPE)


MESSAGE( "BUILD_TYPE = ${BUILD_TYPE}" )
MESSAGE( "BUILD_DIR = ${BUILD_DIR}" )
MESSAGE( "DEBUG = ${DEBUG}" )
MESSAGE( "CMAKE_C_COMPILER = ${CMAKE_C_COMPILER}" )
MESSAGE( "CMAKE_C_FLAGS = ${CMAKE_C_FLAGS}" )
MESSAGE( "CMAKE_CXX_COMPILER = ${CMAKE_CXX_COMPILER}" )
MESSAGE( "CMAKE_CXX_FLAGS = ${CMAKE_CXX_FLAGS}" )
MESSAGE( "OPENGL = ${OPENGL}" )
MESSAGE( "OGG = ${OGG}" )
MESSAGE( "TREMOR = ${TREMOR}" )
MESSAGE( "64BIT = ${HAVE_64_BIT}" )

=== debian/changelog ===
commander-genius (3.6.1+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #737587).

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 10 Dec 2025 14:46:20 +0100

=== debian/control ===
Source: commander-genius
Section: contrib/games
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat(= 13), cmake, libsdl2-dev, libsdl2-mixer-dev, libogg-dev, libvorbis-dev, libsdl2-image-dev, libsdl2-ttf-dev, libcurl4-openssl-dev
Homepage: https://clonekeenplus.sourceforge.net
Standards-Version: 4.7.2

Package: commander-genius
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: game-data-packager
Description: engine used to play the "Commander Keen" game series
 Commander-Genius aka CloneKeenPlus is an engine which interprets
 Commander Keen 1-6 (Vorticons and Galaxy Series).
 .
 You will need the original, non-distributable, game data files.
 You can install them by using the game-data-packager tool.
 .
 Commander Keen 1 and 4 are freely available.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release

override_dh_auto_install:

execute_after_dh_install:
	mv debian/commander-genius/usr/share/applications/cgenius.desktop \
	   debian/commander-genius/usr/share/applications/io.sourceforge.clonekeenplus.desktop

=== debian/watch ===
Version: 5
Template: Github
Owner: gerstrong
Project: Commander-Genius
Repack: yes
Repacksuffix: +dfsg
Dversion-Mangle: auto
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@SEMANTIC_VERSION@
